<template>
  <div
    id="containerTwoSection"
    ref="containerTwoSection"
    class="ob-two-panel-container"
    :data-qa="dataQa"
    @mouseup="mouseupResize"
  >
    <div
      :style="{width: elWidthLeft}"
      class="ob_left_panel panel"
    >
      <div class="ob_left_panel_header panel_header">
        <slot name="left-header" />
        {{ leftCaption }}
      </div>
      <div
        class="ob_left_panel_content panel_content"
      >
        <slot name="left" />
      </div>
    </div>
    <div
      class="ob-resize-item"
      @mousedown="mousedownResize"
    />
    <div
      :style="{width: elWidthRight}"
      class="ob_right_panel panel"
    >
      <div class="ob_right_panel_header panel_header">
        <slot name="right-header" />
        {{ rightCaption }}
      </div>
      <div
        class="ob_right_panel_content panel_content"
        :class="{'full-content': heightFull}"
      >
        <slot name="right" />
      </div>
    </div>
  </div>
</template>
<script>
export default {
  name: 'ObTwoPanels',
  components: {},
  props: {
    leftCaption: String,
    rightCaption: String,
    backlink: Object,
    heightFull: {
      type: Boolean,
      default: false
    },
    minLeftWidth: {
      type: Number,
      default: 320
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      allWidth: 100,
      elWidthLeft: 50,
      elWidthRight: 50,
      allHeight: 0,
      elHeight: 0,
      headerElHeight: 0,
      isResize: false,
      isMouseDown: false,
      containerHeight: 'calc(100vh - 134px)'
    }
  },
  mounted () {
    document.getElementById('containerTwoSection').addEventListener('mousemove', (e) => {
      if (this.isMouseDown && (this.allWidth - (e.x + 5) > this.minLeftWidth)) {
        let positionEl = e.x - 5
        this.elWidthLeft = positionEl >= this.minLeftWidth ? positionEl + 'px' : this.minLeftWidth + 'px'
        this.elWidthRight = positionEl >= this.minLeftWidth ? this.allWidth - (e.x + 5) + 'px' : this.allWidth - 330 + 'px'
      }
    })
    this.allWidth = this.$refs.containerTwoSection.clientWidth
    if (document.getElementsByClassName('ob-main-template-content').length > 0) {
      this.containerHeight = document.getElementsByClassName('ob-main-template-content')[0].clientHeight + 'px'
    }
    this.ifFull()
  },
  updated () {
    this.ifFull()
  },
  methods: {
    goBack () {
      this.$router.push(this.backlink)
    },
    mousedownResize () {
      this.isMouseDown = true
    },
    mouseupResize () {
      this.isMouseDown = false
    },
    ifFull () {
      if (this.heightFull) {
        if (document.getElementsByClassName('ob-main-template-header')[0]) {
          this.headerElHeight = document.getElementsByClassName('ob-main-template-header')[0].clientHeight
        }
        this.allHeight = document.documentElement.clientHeight
        this.elHeight = this.allHeight - this.headerElHeight
        document.getElementsByClassName('ob_left_panel')[0].style.height = (this.elHeight - 20) + 'px'
        document.getElementsByClassName('ob_right_panel')[0].style.height = (this.elHeight - 20) + 'px'
      }
    }
  }
}
</script>
<style
        scoped
        lang="scss"
>
  @import "../../static/css/mixins";
  .ob-two-panel-container {
    width: 100%;
    position: relative;
    display: flex;
    justify-content: space-between;
    height: 100%;
    padding-bottom: 20px;
    .panel {
      width: calc(50% - 5px);
      .panel_content {
        background: $background-white;
        -webkit-box-shadow: 0 0 10px rgba($color-blue-navy-blue, 0.25);
        box-shadow: 0 0 10px rgba($color-blue-navy-blue, 0.25);
        width: 100%;
        position: relative;
        min-height: calc(100% - 50px);
      }
      .panel_header {
        height: 50px;
        @include font-mixin(12px, 16px, 700, $color-blue-smalt, 1.6px, uppercase);
        padding: 18px 0 15px 10px;
      }
    }
    .ob-resize-item {
      width: 10px;
      float: left;
      margin: 50px 0 0;
      cursor: col-resize;
      &:before {
        position: absolute;
        top: 50%;
        transform: translateY(-50%);
        display: inline-block;
        content: '';
        width: 4px;
        height: 4px;
        margin: 0 3px;
        border-radius: 50%;
        background-color: $color-blue-navy-blue;
        box-shadow: 0 8px 0 $color-blue-navy-blue, 0 16px 0 $color-blue-navy-blue;
      }
    }
    .ob_left_panel {
      display: flex;
      flex-direction: column;
      padding: 0 0 0 15px;
      .ob_left_panel_header {
      }
      .ob_left_panel_content {
        display: flex;
        flex-direction: column;
        overflow: hidden;
      }
    }
    .ob_right_panel {
      display: flex;
      flex-direction: column;
      padding: 0 15px 0 0;
      .ob_right_panel_header {
      }
      .ob_right_panel_content {
        display: flex;
        flex-direction: column;
        &.full-content{
          overflow: scroll;
        }
      }
    }
  }
</style>
